local CombuctorSet = Combuctor:GetModule("Sets")

-- Profession Icon Name
local IconPathName="Interface/Icons/INV_Misc_Gem_Sapphire_02"

local Class_TradeGoods=select(6, GetAuctionItemClasses())
local Class_Gem=select(10, GetAuctionItemClasses())

SubClass_MetalStone=select(4, GetAuctionItemSubClasses(6));


-- Tab Names
local TN={}
TN.All=ALL
TN.JC="Jewelcrafting"; 

function TN.isJCGood(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	return TN.isReagent(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
		or TN.isOre(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
		or TN.isCutGem(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
		or TN.isOther(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
end

function TN.isReagent(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	return (name == "Delicate Copper Wire")
		or name == "Bronze Setting"
		or name == "Jeweler's Setting"
		or name == "Thorium Setting"
		or name == "Large Fang"
		or name == "Soul Dust"
		or name == "Mana Potion"
		or name == "Greater Mana Potion"
		or name == "Elixir of Ogre's Strength"
		or name == "Shadow Oil"
		or name == "Mithril Filigree"
		or name == "Elemental Earth"
		or name == "Elemental Water"
		or name == "Heart of Fire"
		or name == "Breath of Wind"
		or name == "Vision Dust"
		or name == "Flask of Mojo"
		or name == "Flask of Big Mojo"
		or name == "Powerful Mojo"
		or name == "Core of Earth"
		or name == "Globe of Water"
		or name == "Essence of Earth"
		or name == "Essence of Fire"
		or name == "Essence of Undeath"
		or name == "Heart of the Wild"
		or name == "Large Radiant Shard"
		or name == "Arcane Crystal"
		or name == "Demonic Rune"
		or name == "Living Essence"
		or name == "Adamantite Powder"
		or name == "Purified Draenic Water"
		or name == "Mercurial Adamantite"
		or name == "Mote of Water" 
		or name == "Crystallized Earth"
		or name == "Bloodstone"
		or name == "Primal Shadow"
		or name == "Primal Water"
		or name == "Primal Fire"
		or name == "Primal Air"
		or name == "Primal Earth"
		or name == "Primal Life"
		or name == "Primal Mana"
		or name == "Primal Nether"
		or name == "Primal Might"
		or name == "Infinite Dust" 
		or name == "Sunmote"
		or name == "Hardened Khorium"
		or name == "Eternal Earth"
		or name == "Eternal Shadow"
		or name == "Eternal Fire"
		or name == "Eternal Water"
		or name == "Frozen Orb"
		or name == "Dream Shard"
		or name == "Eternal Air"
		or name == "Eternal Life"
		or name == "Volatile Fire"
		or name == "Volatile Water"
		or name == "Volatile Life"
		or name == "Volatile Air"
		or name == "Volatile Earth"
		or name == "Stardust"
		or TN.isUncutGem(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
		or TN.isBar(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	    or TN.isStone(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc);
end

function TN.isCutGem(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if type ~= Class_Gem then return false; end

	return string.find(name, " Tourmaline") ~= nil
		or ((string.find(name, " Zircon") ~= nil) and (name ~= "Majestic Zircon"))
		or ((string.find(name, " Amber") ~= nil) and (name ~= "King's Amber"))
		or ((string.find(name, " Ruby") ~= nil) and (name ~= "Fire Ruby") 
			and (name ~= "Living Ruby") and (name ~= "Inferno Ruby") 
			and (name ~= "Scarlet Ruby") and (name ~= "Cardinal Ruby"))
		or string.find(name, " Dawnstone") ~= nil
		or string.find(name, " Topaz") ~= nil
		or string.find(name, " Blood Garnet") ~= nil
		or string.find(name, " Deep Peridot") ~= nil
		or string.find(name, " Flame Spessarite") ~= nil
		or string.find(name, " Shadow Draenite") ~= nil
		or string.find(name, " Azure Moonstone") ~= nil
		or string.find(name, " Golden Draenite") ~= nil
		or string.find(name, " Crimson Spinel") ~= nil
		or string.find(name, " Bladestone") ~= nil
		or string.find(name, " Fire Opal") ~= nil
		or string.find(name, " Amani Jewel") ~= nil
		or string.find(name, " Pyrestone") ~= nil
		or string.find(name, " Tanzanite") ~= nil
		or string.find(name, " Spencerite") ~= nil
		or string.find(name, " Seaspray Emerald") ~= nil
		or string.find(name, " Amethyst") ~= nil
		or string.find(name, " Chrysoprase") ~= nil
		or string.find(name, " Lionseye") ~= nil
		or string.find(name, " Eye of Zul") ~= nil
		or string.find(name, " Ametrine") ~= nil
		or string.find(name, " Chimera's Eye") ~= nil
		or string.find(name, " Dragon's Eye") ~= nil
		or string.find(name, " Empyrean Sapphire") ~= nil
		or string.find(name, " Stormjewel") ~= nil
		or string.find(name, " Dreadstone") ~= nil
		or string.find(name, "Falling Star") ~= nil
		or string.find(name, " Majestic Zircon") ~= nil
		or string.find(name, " Earthstorm Diamond") ~= nil
		or string.find(name, " Skyfire Diamond") ~= nil
		or string.find(name, " Noble Topaz") ~= nil
		or string.find(name, " Talasite") ~= nil
		or string.find(name, " Unstable Diamond") ~= nil
		or string.find(name, " Mossjewel") ~= nil
		or string.find(name, " Nightseye") ~= nil
		or string.find(name, " Earthsiege Diamond") ~= nil
		or string.find(name, " Shadowspirit Diamond") ~= nil
		or string.find(name, " Nightseye") ~= nil
		or string.find(name, " Monarch Topaz") ~= nil
		or string.find(name, " Skyflare Diamond") ~= nil
		or string.find(name, " Ember Topaz") ~= nil
		or string.find(name, " Demonseye") ~= nil
		or string.find(name, " Twilight Opal") ~= nil
		or string.find(name, " Forest Emerald") ~= nil
		or string.find(name, " Starflare Diamond") ~= nil
		or ((string.find(name, " Citrine") ~= nil) and (name ~= "Huge Citrine"))
		or string.find(name, " Star of Elune") ~= nil
		or string.find(name, " Windfire Diamond") ~= nil
		or string.find(name, " Shadow Crystal") ~= nil
		or string.find(name, " Dark Jade") ~= nil
		or string.find(name, " Sun Crystal") ~= nil
		or string.find(name, " Chalcedony") ~= nil
		or string.find(name, " Autumn's Glow") ~= nil
		or string.find(name, " Earthshatter Diamond") ~= nil
		or string.find(name, " Sky Sapphire") ~= nil
		or string.find(name, " Nightstone") ~= nil
		or string.find(name, " Hessonite") ~= nil
		or string.find(name, " Carnelian") ~= nil
		or string.find(name, " Alicite") ~= nil
		or string.find(name, " Jasper") ~= nil
		or string.find(name, " Zephyrite") ~= nil
		or string.find(name, " Chimera's Eye") ~= nil
		or string.find(name, " Dream Emerald") ~= nil
		or string.find(name, " Amberjewel") ~= nil
		or string.find(name, " Ocean Sapphire") ~= nil
		or string.find(name, " Cogwheel") ~= nil
		
		or name == "Don Amancio's Heart"
		or name == "Don Rodrigo's Heart"
		or name == "Purified Shadow Pearl"
		or name == "Deadly Citrine"
		or name == "Don Julio's Heart"
		or name == "Facet of Eternity"
		or name == "Kailee's Rose"
		or name == "Stone of Blades"
		or name == "Void Sphere"
		or name == "Eye of the Sea"
		or name == "Heavy Tonk Armor"
		or name == "Prismatic Sphere" 
		or name == "Chromatic Sphere" 
		or name == "Enchanted Tear" 
		or name == "Enchanted Pearl"
		or name == "Infinite Sphere"
 		or name == "Kharmaa's Grace" 
 		or name == "Nightmare Tear" 
 		or name == "Strange Gem";
		
end

function TN.isUncutGem(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	return TN.isGem(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc) 
		and not TN.isCutGem(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
end

function TN.isOther(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	
	return name == "Simple Grinder"
		or string.find(name, "Figurine") ~= nil
		or string.find(name, "Statue") ~= nil;
end

function TN.isGem(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	
	return type==Class_Gem;
end 

function TN.isOre(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	
	return string.find(name, "Ore") ~= nil and subType==SubClass_MetalStone;
end

function TN.isBar(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end
	
	if subType ~= SubClass_MetalStone then return false; end;

	return string.find(name, "Bar") or name == "Truegold";
end


function TN.isStone(player, bagType, name, link, quality, level, ilvl, type, subType, stackCount, equipLoc)
	if not subType then return false end

	return string.find(name, "Stone") and subType==SubClass_MetalStone;
end

CombuctorSet:Register(TN.JC, IconPathName, TN.isJCGood)

CombuctorSet:RegisterSubSet(TN.All,		TN.JC,nil,TN.isJCGood)
CombuctorSet:RegisterSubSet("Jewels", 	TN.JC,nil,TN.isCutGem)
CombuctorSet:RegisterSubSet("Ores",		TN.JC,nil,TN.isOre)
CombuctorSet:RegisterSubSet("Reagents",	TN.JC,nil,TN.isReagent)
CombuctorSet:RegisterSubSet("Other",	TN.JC,nil,TN.isOther)
